//#define PATCH_ENABLE
//gcc -o fixcrc.exe -s fixcrc.c

#include <stdio.h>
#include <stdlib.h>

typedef unsigned int u32;
typedef unsigned char u8;
typedef unsigned short u16;

int crc16(char *addr, int num, int crc) //XMODEM type http://mdfs.net/Info/Comp/Comms/CRC16.htm
{
int i;
int poly=0x1021;

for (; num>0; num--)               /* Step through bytes in memory */
  {
  crc = crc ^ (*addr++ << 8);      /* Fetch byte from memory, XOR into CRC top byte*/
  for (i=0; i<8; i++)              /* Prepare to rotate 8 bits */
    {
    crc = crc << 1;                /* rotate */
    if (crc & 0x10000)             /* bit 15 was set (now bit 16)... */
      crc = (crc ^ poly) & 0xFFFF; /* XOR with XMODEM polynomic */
                                   /* and ensure CRC remains 16-bit value */
    }                              /* Loop for 8 bits */
  }                                /* Loop until num=0 */
  return(crc);                     /* Return updated CRC */
}

int main(int argc, char** argv) {
   u32 SIZE=0xc81E;
   u16 res=0;
   char *fname=argv[1];
   u8 *buffer=malloc(SIZE);
	
   printf("%s\n",fname);
   FILE *f=fopen(fname,"rb+");
   if(f){
	   fread(buffer,1,SIZE,f);
	   
	   res=(u16)crc16(buffer,SIZE,0);
	   
	   printf("CRC = %04X\n",res);
	   
	   res=(res & 0xFF)<<8 | (res>>8); //little -> big endian
	   
	   #ifdef PATCH_ENABLE
	   fseek(f,SIZE,SEEK_SET);
	   fwrite(&res,2,1,f);
	   #endif

	   fclose(f);
   }
   else{
	   printf("%s could not be opened! \n",fname);
   }
  
   return 0;
}